// IsGetObj.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <windows.h>
#include <comdef.h>
#include <atlbase.h>


#define CHECKHRESULT(__x) if (FAILED(__x)) return __x;

//This DLL shows example on how to simulate VB's ForEach and GetObject functionality.

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}


long __stdcall ForEachStart(VARIANT *pCol, VARIANT *pVar)
{
	if (pCol->vt != VT_DISPATCH || pCol->pdispVal == 0)
		return E_INVALIDARG;

	try
	{
		unsigned int                uArgErr;
		DISPPARAMS                  disparams = {0};
		CComVariant                 varResult;
		pCol->pdispVal->Invoke(DISPID_NEWENUM, IID_NULL, 0, DISPATCH_PROPERTYGET, &disparams, &varResult, NULL, &uArgErr);

		return varResult.Detach(pVar);
	}
	catch(...)
	{
		return E_UNEXPECTED;
	}
}


long __stdcall ForEachGetNextItem(VARIANT *pEnum, VARIANT *pVar)
{
	try
	{
		if (pEnum->vt != VT_UNKNOWN || pEnum->punkVal == NULL)
			return E_INVALIDARG;

		CComQIPtr<IEnumVARIANT> pEnumVariant = pEnum->punkVal;

		if (!pEnum)
			return E_NOINTERFACE;

	    ULONG                       celtFetched;
		CComVariant var;

		if (S_FALSE == pEnumVariant->Next(1, &var, &celtFetched))  //No more items.
			return E_FAIL;

		if (var.vt != VT_DISPATCH)
			CHECKHRESULT(var.ChangeType(VT_DISPATCH));

		return var.Detach(pVar);

	}
	catch(...)
	{
		return E_UNEXPECTED;
	}
}


//At this moment, ignore the case neither szFile or szProgID is empty.
long __stdcall VBGetObject(LPCTSTR szFile, LPCTSTR szProgID, VARIANT *pVar)
{
	if (!pVar)
		return E_INVALIDARG;

	CComQIPtr<IDispatch> spDisp;

	try
	{
		USES_CONVERSION;
		if (szFile && lstrlen(szFile))
		{
			CHECKHRESULT(::CoGetObject(T2W(szFile), 0, IID_IDispatch, reinterpret_cast<void**>(&spDisp)));

			CComVariant varObject = spDisp;
			
			return varObject.Detach(pVar);
		}
		else if (szProgID && lstrlen(szProgID))
		{
			CLSID clsid;
			CHECKHRESULT(::CLSIDFromProgID(T2W(szProgID), &clsid));

			CComPtr<IMoniker> spMoniker;
			CHECKHRESULT(::CreateItemMoniker(L"!", CComBSTR(clsid), &spMoniker));

			CComPtr<IRunningObjectTable> spRot;
			CHECKHRESULT(::GetRunningObjectTable(0, &spRot));

			CComPtr<IUnknown> pUnk;
			CHECKHRESULT(spRot->GetObject(spMoniker, &pUnk));

			spDisp = pUnk;

			if (spDisp)
			{
				CComVariant varObject = spDisp;
			
				return varObject.Detach(pVar);
			}
			else
				return E_NOINTERFACE;
		}
		else
			return E_INVALIDARG;
	}
	catch(...)
	{
		return E_UNEXPECTED;
	}
}